# AUTOGENERATED FROM 'musicbot/queries/remove.edgeql' WITH:
#     $ edgedb-py -I musicbot-prod --dir musicbot/queries


from __future__ import annotations

import dataclasses
import uuid

import edgedb


class NoPydanticValidation:
    @classmethod
    def __get_pydantic_core_schema__(cls, _source_type, _handler):
        # Pydantic 2.x
        from pydantic_core.core_schema import any_schema

        return any_schema()

    @classmethod
    def __get_validators__(cls):
        # Pydantic 1.x
        from pydantic.dataclasses import dataclass as pydantic_dataclass

        pydantic_dataclass(cls)
        cls.__pydantic_model__.__get_validators__ = lambda: []
        return []


@dataclasses.dataclass
class RemoveResult(NoPydanticValidation):
    id: uuid.UUID


async def remove(
    executor: edgedb.AsyncIOExecutor,
    *,
    path: str,
) -> list[RemoveResult]:
    return await executor.query(
        """\
        update Music
        filter contains(.paths, <str>$path)
        set {folders := (select .folders filter @path != <str>$path)};\
        """,
        path=path,
    )
