# AUTOGENERATED FROM 'musicbot/queries/soft_clean.edgeql' WITH:
#     $ edgedb-py -I musicbot-prod --dir musicbot/queries


from __future__ import annotations

import dataclasses
import uuid

import edgedb


class NoPydanticValidation:
    @classmethod
    def __get_pydantic_core_schema__(cls, _source_type, _handler):
        # Pydantic 2.x
        from pydantic_core.core_schema import any_schema

        return any_schema()

    @classmethod
    def __get_validators__(cls):
        # Pydantic 1.x
        from pydantic.dataclasses import dataclass as pydantic_dataclass

        pydantic_dataclass(cls)
        cls.__pydantic_model__.__get_validators__ = lambda: []
        return []


@dataclasses.dataclass
class SoftCleanResult(NoPydanticValidation):
    id: uuid.UUID
    musics_deleted: int
    albums_deleted: int
    artists_deleted: int
    genres_deleted: int
    keywords_deleted: int


async def soft_clean(
    executor: edgedb.AsyncIOExecutor,
) -> SoftCleanResult:
    return await executor.query_single(
        """\
        select {
            musics_deleted := count((delete Music filter not exists .folders)),
            albums_deleted := count((delete Album filter not exists .musics)),
            artists_deleted := count((delete Artist filter not exists .musics)),
            genres_deleted := count((delete Genre filter not exists .musics)),
            keywords_deleted := count((delete Keyword filter not exists .musics))
        };\
        """,
    )
