# AUTOGENERATED FROM 'musicbot/queries/upsert_genre.edgeql' WITH:
#     $ edgedb-py -I musicbot-prod --dir musicbot/queries


from __future__ import annotations

import dataclasses
import uuid

import edgedb


class NoPydanticValidation:
    @classmethod
    def __get_pydantic_core_schema__(cls, _source_type, _handler):
        # Pydantic 2.x
        from pydantic_core.core_schema import any_schema

        return any_schema()

    @classmethod
    def __get_validators__(cls):
        # Pydantic 1.x
        from pydantic.dataclasses import dataclass as pydantic_dataclass

        pydantic_dataclass(cls)
        cls.__pydantic_model__.__get_validators__ = lambda: []
        return []


@dataclasses.dataclass
class UpsertGenreResult(NoPydanticValidation):
    id: uuid.UUID


async def upsert_genre(
    executor: edgedb.AsyncIOExecutor,
    *,
    genre: str,
) -> UpsertGenreResult:
    return await executor.query_single(
        """\
        select (
            insert Genre {
                name := <str>$genre
            }
            unless conflict on (.name) else (select Genre)
        ) {id}\
        """,
        genre=genre,
    )
